;===================================================================
;                   MAIN.ASM
;===================================================================
         EXTERN  GETDEC:FAR
         EXTERN  NEWLINE:FAR
         EXTERN  PUTSTRNG:FAR
         EXTERN  NRANDOM:FAR
         EXTERN  RESEED:FAR
         EXTERN  PUTDEC:FAR
;===================================================================
        .MODEL  LARGE
        .STACK  512
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
        .DATA
UPPER      DW 9999
LOWER      DW 0
HIGHCOUNT  DW 0
LOWCOUNT   DW 0
EVENCOUNT  DW 0
ODDCOUNT   DW 0
PROMPT1    DB 'Enter 0 for Random Seed or 1 for 5555h Seed and Range 0-9999: '
PROMPT2    DB 'Enter Lower End of Range: '
PROMPT3    DB 'Enter Upper End of Range: '
PROMPT4    DB 'Enter 0 to Exit or 1 to Run Again: '
ENTRY_ERR  DB 'Lower must be less than Upper - Try Again'
HIGHHEADER DB 'High: '
LOWHEADER  DB 'Low:  '
ODDHEADER  DB 'Odd:  '
EVENHEADER DB 'Even: '
SPACE      DB '  '
;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
        .CODE
        ASSUME  DS:DGROUP
;===================================================================

MAIN    PROC

        MOV     AX,DGROUP           ;SET DS-REGISTER TO POINT TO
        MOV     DS,AX               ;DATA SEGMENT
        MOV     ES,AX               ;AND ES ALSO

BEGINNING:
        CALL    NEWLINE
        MOV     DI,OFFSET PROMPT1
        MOV     CX,SIZEOF PROMPT1
        CALL    PUTSTRNG
        CALL    GETDEC
        PUSH    AX
        CALL    NEWLINE
        POP     BX                  ;BL=1 to seed 5555h
        CALL    RESEED              ;BL=0 uses timer
        CMP     BL,0
        JNE     RUN_TEST

RANGE_ENTRY:
        MOV     DI,OFFSET PROMPT2
        MOV     CX,SIZEOF PROMPT2
        CALL    PUTSTRNG
        CALL    GETDEC
        MOV     LOWER,AX
        CALL    NEWLINE

        MOV     DI,OFFSET PROMPT3
        MOV     CX,SIZEOF PROMPT3
        CALL    PUTSTRNG
        CALL    GETDEC
        MOV     UPPER,AX
        CALL    NEWLINE
        CMP     AX,LOWER
        JG      START_LOOP

        MOV     DI,OFFSET ENTRY_ERR
        MOV     CX,SIZEOF ENTRY_ERR
        CALL    PUTSTRNG
        CALL    NEWLINE
        CALL    NEWLINE
        JMP     RANGE_ENTRY

RUN_TEST:
        MOV     LOWER,0
        MOV     UPPER,9999

START_LOOP:
        MOV     CX,10               ;OUTER LOOP COUNT = 10

LINE_LOOP:
        PUSH    CX                  ;SAVE OUTER LOOP COUNT
        MOV     CX,10               ;INNER LOOP COUNT = 10

NUM_LOOP:
        PUSH    CX                  ;SAVE INNER LOOP COUNT
        MOV     AX,UPPER            ;PUSH UPPER
        PUSH    AX
        MOV     AX,LOWER            ;PUSH LOWER
        PUSH    AX
        CALL    NRANDOM
        MOV     BH,1
        CALL    PUTDEC
        MOV     DI,OFFSET SPACE
        MOV     CX, 1
        CALL    PUTSTRNG
        MOV     BX,UPPER            ;CALCULATE MID-RANGE
        SUB     BX,LOWER
        SHR     BX,1
        ADD     BX,LOWER
        CMP     AX,BX
        JGE     HIGH_SEQUENCE

        INC     LOWCOUNT
        JMP SHORT HILO_COUNTED

HIGH_SEQUENCE:
        INC     HIGHCOUNT

HILO_COUNTED:
        SAR     AX,1
        JC      ODDS

        INC     EVENCOUNT
        JMP     SHORT EVENODD_COUNTED

ODDS:
        INC     ODDCOUNT

EVENODD_COUNTED:
        POP     CX                   ;     POP LOOP_COUNT
        LOOP    NUM_LOOP             ;     DECREMENT LOOP_COUNT

        CALL    NEWLINE
        POP     CX                   ;     POP LOOP_COUNT
        LOOP    LINE_LOOP            ;     DECREMENT LOOP_COUNT

;============display

        CALL    NEWLINE
        CALL    NEWLINE

        MOV     DI,OFFSET HIGHHEADER
        MOV     CX,SIZEOF HIGHHEADER
        CALL    PUTSTRNG
        MOV     AX,HIGHCOUNT
        CALL    PUTDEC
        CALL    NEWLINE

        MOV     DI,OFFSET LOWHEADER
        MOV     CX,SIZEOF LOWHEADER
        CALL    PUTSTRNG
        MOV     AX,LOWCOUNT
        CALL    PUTDEC
        CALL    NEWLINE

        MOV     DI,OFFSET EVENHEADER
        MOV     CX,SIZEOF EVENHEADER
        CALL    PUTSTRNG
        MOV     AX,EVENCOUNT
        CALL    PUTDEC
        CALL    NEWLINE

        MOV     DI,OFFSET ODDHEADER
        MOV     CX,SIZEOF ODDHEADER
        CALL    PUTSTRNG
        MOV     AX,ODDCOUNT
        CALL    PUTDEC
        CALL    NEWLINE

        CALL    NEWLINE
        MOV     DI,OFFSET PROMPT4
        MOV     CX,SIZEOF PROMPT4
        CALL    PUTSTRNG
        CALL    GETDEC
        CMP     AL,0
        JE      EXIT_PROGRAM

        SUB     AX,AX
        MOV     HIGHCOUNT,AX
        MOV     LOWCOUNT,AX
        MOV     EVENCOUNT,AX
        MOV     ODDCOUNT,AX
        JMP     BEGINNING

;==================

EXIT_PROGRAM:
        MOV     AX,4C00H
        INT     21H

MAIN    ENDP

        END MAIN

