;===================================================================
;                   RESEED.ASM
;      r a n d o m   n u m b e r   g e n e r a t o r
; GENERATES PSEUDO-RANDOM INTEGERS IN THE RANGE LOWER TO UPPER
; INPUT: BL = 0 - gets a seed value from the time-of day counter
;        BL <> 0 - sets the test seed value of 5555h
;
;===================================================================
         .MODEL  LARGE     
;===================================================================
        EXTERN  SEED:WORD
        PUBLIC  RESEED
;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
        .CODE   
        ASSUME  DS:SEG SEED
;===================================================================

RESEED  PROC    FAR PUBLIC USES AX CX DX DS

        MOV     AX,SEG SEED            ;SET DS-REGISTER TO POINT
        MOV     DS,AX                  ;TO FAR DATA SEGMENT
        PUSHF                         
        CMP     BL,0
        JNE     NOTZERO

        MOV     AH,0                   ;     SEED = LOWER HALF OF
        INT     1AH                    ;            TIME OF DAY CLOCK
        MOV     SEED,DX
        JMP SHORT ENDD

NOTZERO:
        MOV     SEED,5555h

ENDD:
        POPF                         
        RET
         
RESEED  ENDP

        END

